/*
 * EXPLORADOR PULSAR
 * walgarcia@gmail.com
 * 20130225 :- we're not alone!
 *
 */

/*

# This file was produced by the NASA Exoplanet Archive  http://exoplanetarchive.ipac.caltech.edu
# Sun Feb 24 15:12:40 2013
#


 */



class ObjetoPlaneta {
  int     rowid        ;
  String  pl_hostname  ;
  String  pl_letter    ;
  String  pl_discmethod;
  float   pl_orbper    ;
  float   pl_orbsmax   ;
  float   pl_orbeccen  ;
  float   pl_massj     ;
  float   pl_msinij    ;
  float   pl_radj      ;
  float   pl_dens      ;
  float   pl_orbincl   ;
  float   pl_ttvflag   ;
  float   RA           ;
  float   DEC          ;
  float   st_dist      ;
  float   st_vj        ;
  float   st_teff      ;
  float   st_mass      ;
  float   st_rad       ;
  String  hd_name      ;
  String  hip_name     ;
  float   st_pmra      ;
  float   st_pmdec     ;
  float   st_radv      ;
  float   st_umbj      ;
  float   st_bmvj      ;
  float   st_vjmic     ;
  float   pl_status    ;
  float   ra           ;
  float   dec          ;
  
  color col;
  int     ronda = 0    ;

  // Constructor function
  ObjetoPlaneta() {};
  
  // Load exoplanet data from a comma-delimited string (see key at top of class)
  void fromCSV(String[] sa) {
    rowid         = int  (sa[ 0]);
    pl_hostname   =       sa[ 1] ;
    pl_letter     =       sa[ 2] ;
    pl_discmethod =       sa[ 3] ;
    pl_orbper     = float(sa[ 4]);
    pl_orbsmax    = float(sa[ 5]);
    pl_orbeccen   = float(sa[ 6]);
    pl_massj      = float(sa[ 7]);
    pl_msinij     = float(sa[ 8]);
    pl_radj       = float(sa[ 9]);
    pl_dens       = float(sa[10]);
    pl_orbincl    = float(sa[11]);
    pl_ttvflag    = float(sa[12]);
    RA            = float(sa[13]);
    DEC           = float(sa[14]);
    st_dist       = float(sa[15]);
    st_vj         = float(sa[16]);
    st_teff       = float(sa[17]);
    st_mass       = float(sa[18]);
    st_rad        = float(sa[19]);
    hd_name       =       sa[20] ;
    hip_name      =       sa[21] ;
    st_pmra       = float(sa[22]);
    st_pmdec      = float(sa[23]);
    st_radv       = float(sa[24]);
    st_umbj       = float(sa[25]);
    st_bmvj       = float(sa[26]);
    st_vjmic      = float(sa[27]);
    pl_status     = float(sa[28]);
    ra  = RA ;
    dec = DEC;
  }

  // Initialize pixel-based motion data, color, etc. from exoplanet data
  void init() {

  }

  // Update
  void update() {
    //if (st_radv >0 ){
      ra   = (RA  ) + (st_pmra  * cos(st_radv + (universalTIK/pl_orbper)) / 100.0);
      dec  = (DEC ) + (st_pmdec * sin(st_radv + (universalTIK/pl_orbper)) / 100.0);
      if (ra >= 360 ) ra = 0;
      if (dec >= 90 ) dec =-90;
    //}
  }

  // Draw
  void render() {

    pushMatrix();
    float x1    = ra * width / 360.0;
    float y1    = (dec + 90.0) * (height-STATBAR) / 180.0;
    translate(x1,y1);
    
    fill(col);
    noStroke();
    if (ronda > 0) {
      ellipse (0.0,0.0,tzoom + 15 ,tzoom+ 15);
    }else {
      ellipse (0.0,0.0,tzoom + 1 ,tzoom+ 1);
    }

    popMatrix();
     

  }
}

